-- UPDATE 17.01.2017

-- NVDEV-554
-- brise sve definicije alarma i kriterione koji su definisani za component -

DELETE
FROM filter.criterion c 
USING nms_conf.alarm a
WHERE a.criterion = c.id AND a.scopetype = 'COMPONENT';

-- brise sve eventove koji se odnose na NMS modul i imaju kompozitni scope id
DELETE FROM event_alarm_action.event e WHERE e.id_cip_sys_module IN (SELECT id_cip_sys_module FROM framework.module WHERE tag = 'nms') AND LOWER(source_desc) LIKE '%component%';

-- END OF UPDATE 17.01.2017 
  
INSERT INTO framework.db_version(patch_number, patch_date) VALUES (62, current_timestamp);