-- UPDATE 10.04.2017
-- NVDEV-668 dodaje system property-e za SFlow

insert into framework.system_property (name, tag, type, value)
   values ('S_FLOW_SOCKET_PORT', 'netflow', 'INTEGER', '6343');
   
insert into framework.system_property (name, tag, type, value)
   values ('S_FLOW_SOCKET_TIMEOUT', 'netflow', 'INTEGER', '5');
   
-- END OF UPDATE 10.04.2017
   
   
-- UPDATE 20.04.2017
-- NVDEV-684 dodaje za LDAP

-- Table: users."ldap_configuration"

-- DROP TABLE users."ldap_configuration";

CREATE TABLE users.ldap_configuration
(
  id_ldap_configuration integer NOT NULL,
  server_address character varying(250) NOT NULL,
  port integer,
  ssl boolean NOT NULL DEFAULT false,
  authentication_type smallint NOT NULL,
  authentication_method character varying(250),
  domain_name character varying(250) NOT NULL,
  --category for users
  organization_unit_attr character varying(250),
  organization_unit_value character varying(250),
  --the attribute where to search for user
  user_name_attr character varying(250) NOT NULL,
  user_object_class character varying(250) NOT NULL,
  
  default_config integer NOT NULL,
  --group name
  group_name character varying(250) NOT NULL,
  group_name_attr character varying(250) NOT NULL,
  --the attribute where to search for groups
  user_in_group boolean NOT NULL,
  group_object_class character varying(250) NOT NULL,
  --the attribute where to check membership in group with specified group value
  group_member_attr character varying(250) NOT NULL,
  CONSTRAINT pk_ldap_configuration PRIMARY KEY (id_ldap_configuration)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE users.ldap_configuration
  OWNER TO netvizura;
  
ALTER TABLE users."user"
   ALTER COLUMN password DROP NOT NULL;

ALTER TABLE users."user"
  ADD COLUMN ind_ldap_user boolean NOT NULL DEFAULT false;
   
-- END OF UPDATE 20.04.2017

   
INSERT INTO framework.db_version(patch_number, patch_date) VALUES (63, current_timestamp);