-- UPDATE 20.03.2017.

-- NVDEV-658

-- kreiramo entitet TAG i veznu tabelu izmedju device i tag.

CREATE TABLE device.tag
(
   id bigserial NOT NULL, 
   name character varying(200), 
   
   CONSTRAINT pk_tag PRIMARY KEY (id), 
   CONSTRAINT uq_tag_name UNIQUE (name)
) 
WITH (
  OIDS = FALSE
);

ALTER TABLE device.tag
OWNER TO netvizura;


CREATE TABLE device.device_tag
(
  id_device bigint NOT NULL,
  id_tag bigint NOT NULL,
  
  CONSTRAINT pk_device_tag PRIMARY KEY (id_device, id_tag),
  CONSTRAINT fk_device FOREIGN KEY (id_device)
      REFERENCES device.device (id_device) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT fk_tag FOREIGN KEY (id_tag)
      REFERENCES device.tag (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);

ALTER TABLE device.device_tag
OWNER TO netvizura;

INSERT INTO framework.db_version(patch_number, patch_date) VALUES (64, current_timestamp);