-- SNAPSHOT 19.02.2018.

-- dodavanje novih kolona vezanih za exporter konverzacije u g1,g2 i g3 tabele

ALTER TABLE netflow.exporter_device_conversation_g1 RENAME COLUMN byte TO byte_src;
ALTER TABLE netflow.exporter_device_conversation_g1 RENAME COLUMN pack TO pack_src;
ALTER TABLE netflow.exporter_device_conversation_g1 RENAME COLUMN flow TO flow_src;
ALTER TABLE netflow.exporter_device_conversation_g1 ADD COLUMN byte_dst bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_conversation_g1 ADD COLUMN pack_dst bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_conversation_g1 ADD COLUMN flow_dst bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_conversation_g1 ADD COLUMN is_source_initiator boolean DEFAULT true;

ALTER TABLE netflow.exporter_device_conversation_g2 RENAME COLUMN byte TO byte_src;
ALTER TABLE netflow.exporter_device_conversation_g2 RENAME COLUMN pack TO pack_src;
ALTER TABLE netflow.exporter_device_conversation_g2 RENAME COLUMN flow TO flow_src;
ALTER TABLE netflow.exporter_device_conversation_g2 ADD COLUMN byte_dst bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_conversation_g2 ADD COLUMN pack_dst bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_conversation_g2 ADD COLUMN flow_dst bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_conversation_g2 ADD COLUMN is_source_initiator boolean DEFAULT true;

ALTER TABLE netflow.exporter_device_conversation_g3 RENAME COLUMN byte TO byte_src;
ALTER TABLE netflow.exporter_device_conversation_g3 RENAME COLUMN pack TO pack_src;
ALTER TABLE netflow.exporter_device_conversation_g3 RENAME COLUMN flow TO flow_src;
ALTER TABLE netflow.exporter_device_conversation_g3 ADD COLUMN byte_dst bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_conversation_g3 ADD COLUMN pack_dst bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_conversation_g3 ADD COLUMN flow_dst bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_conversation_g3 ADD COLUMN is_source_initiator boolean DEFAULT true;

-- dodavanje novih kolona vezanih za interface konverzacije u g1,g2 i g3 tabele

ALTER TABLE netflow.exporter_interface_conversation_g1 RENAME COLUMN byte_in TO byte_src_in;
ALTER TABLE netflow.exporter_interface_conversation_g1 RENAME COLUMN byte_out TO byte_src_out;
ALTER TABLE netflow.exporter_interface_conversation_g1 RENAME COLUMN pack_in TO pack_src_in;
ALTER TABLE netflow.exporter_interface_conversation_g1 RENAME COLUMN pack_out TO pack_src_out;
ALTER TABLE netflow.exporter_interface_conversation_g1 RENAME COLUMN flow_in TO flow_src_in;
ALTER TABLE netflow.exporter_interface_conversation_g1 RENAME COLUMN flow_out TO flow_src_out;
ALTER TABLE netflow.exporter_interface_conversation_g1 ADD COLUMN is_source_initiator boolean DEFAULT true;
ALTER TABLE netflow.exporter_interface_conversation_g1 ADD COLUMN byte_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g1 ADD COLUMN byte_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g1 ADD COLUMN pack_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g1 ADD COLUMN pack_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g1 ADD COLUMN flow_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g1 ADD COLUMN flow_dst_out bigint DEFAULT 0;


ALTER TABLE netflow.exporter_interface_conversation_g2 RENAME COLUMN byte_in TO byte_src_in;
ALTER TABLE netflow.exporter_interface_conversation_g2 RENAME COLUMN byte_out TO byte_src_out;
ALTER TABLE netflow.exporter_interface_conversation_g2 RENAME COLUMN pack_in TO pack_src_in;
ALTER TABLE netflow.exporter_interface_conversation_g2 RENAME COLUMN pack_out TO pack_src_out;
ALTER TABLE netflow.exporter_interface_conversation_g2 RENAME COLUMN flow_in TO flow_src_in;
ALTER TABLE netflow.exporter_interface_conversation_g2 RENAME COLUMN flow_out TO flow_src_out;
ALTER TABLE netflow.exporter_interface_conversation_g2 ADD COLUMN is_source_initiator boolean DEFAULT true;
ALTER TABLE netflow.exporter_interface_conversation_g2 ADD COLUMN byte_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g2 ADD COLUMN byte_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g2 ADD COLUMN pack_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g2 ADD COLUMN pack_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g2 ADD COLUMN flow_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g2 ADD COLUMN flow_dst_out bigint DEFAULT 0;

ALTER TABLE netflow.exporter_interface_conversation_g3 RENAME COLUMN byte_in TO byte_src_in;
ALTER TABLE netflow.exporter_interface_conversation_g3 RENAME COLUMN byte_out TO byte_src_out;
ALTER TABLE netflow.exporter_interface_conversation_g3 RENAME COLUMN pack_in TO pack_src_in;
ALTER TABLE netflow.exporter_interface_conversation_g3 RENAME COLUMN pack_out TO pack_src_out;
ALTER TABLE netflow.exporter_interface_conversation_g3 RENAME COLUMN flow_in TO flow_src_in;
ALTER TABLE netflow.exporter_interface_conversation_g3 RENAME COLUMN flow_out TO flow_src_out;
ALTER TABLE netflow.exporter_interface_conversation_g3 ADD COLUMN is_source_initiator boolean DEFAULT true;
ALTER TABLE netflow.exporter_interface_conversation_g3 ADD COLUMN byte_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g3 ADD COLUMN byte_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g3 ADD COLUMN pack_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g3 ADD COLUMN pack_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g3 ADD COLUMN flow_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_conversation_g3 ADD COLUMN flow_dst_out bigint DEFAULT 0;


-- dodavanje novih kolona vezanih za pattern konverzacije u g1,g2 i g3 tabele

ALTER TABLE netflow.pattern_subnet_conversation_g1 RENAME COLUMN byte_in TO byte_src_in;
ALTER TABLE netflow.pattern_subnet_conversation_g1 RENAME COLUMN byte_out TO byte_src_out;
ALTER TABLE netflow.pattern_subnet_conversation_g1 RENAME COLUMN pack_in TO pack_src_in;
ALTER TABLE netflow.pattern_subnet_conversation_g1 RENAME COLUMN pack_out TO pack_src_out;
ALTER TABLE netflow.pattern_subnet_conversation_g1 RENAME COLUMN flow_in TO flow_src_in;
ALTER TABLE netflow.pattern_subnet_conversation_g1 RENAME COLUMN flow_out TO flow_src_out;

ALTER TABLE netflow.pattern_subnet_conversation_g1 ADD COLUMN byte_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g1 ADD COLUMN byte_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g1 ADD COLUMN pack_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g1 ADD COLUMN pack_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g1 ADD COLUMN flow_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g1 ADD COLUMN flow_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g1 ADD COLUMN is_source_initiator boolean DEFAULT true;


ALTER TABLE netflow.pattern_subnet_conversation_g2 RENAME COLUMN byte_in TO byte_src_in;
ALTER TABLE netflow.pattern_subnet_conversation_g2 RENAME COLUMN byte_out TO byte_src_out;
ALTER TABLE netflow.pattern_subnet_conversation_g2 RENAME COLUMN pack_in TO pack_src_in;
ALTER TABLE netflow.pattern_subnet_conversation_g2 RENAME COLUMN pack_out TO pack_src_out;
ALTER TABLE netflow.pattern_subnet_conversation_g2 RENAME COLUMN flow_in TO flow_src_in;
ALTER TABLE netflow.pattern_subnet_conversation_g2 RENAME COLUMN flow_out TO flow_src_out;

ALTER TABLE netflow.pattern_subnet_conversation_g2 ADD COLUMN byte_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g2 ADD COLUMN byte_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g2 ADD COLUMN pack_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g2 ADD COLUMN pack_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g2 ADD COLUMN flow_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g2 ADD COLUMN flow_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g2 ADD COLUMN is_source_initiator boolean DEFAULT true;


ALTER TABLE netflow.pattern_subnet_conversation_g3 RENAME COLUMN byte_in TO byte_src_in;
ALTER TABLE netflow.pattern_subnet_conversation_g3 RENAME COLUMN byte_out TO byte_src_out;
ALTER TABLE netflow.pattern_subnet_conversation_g3 RENAME COLUMN pack_in TO pack_src_in;
ALTER TABLE netflow.pattern_subnet_conversation_g3 RENAME COLUMN pack_out TO pack_src_out;
ALTER TABLE netflow.pattern_subnet_conversation_g3 RENAME COLUMN flow_in TO flow_src_in;
ALTER TABLE netflow.pattern_subnet_conversation_g3 RENAME COLUMN flow_out TO flow_src_out;

ALTER TABLE netflow.pattern_subnet_conversation_g3 ADD COLUMN byte_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g3 ADD COLUMN byte_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g3 ADD COLUMN pack_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g3 ADD COLUMN pack_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g3 ADD COLUMN flow_dst_in bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g3 ADD COLUMN flow_dst_out bigint DEFAULT 0;
ALTER TABLE netflow.pattern_subnet_conversation_g3 ADD COLUMN is_source_initiator boolean DEFAULT true;


-- dodavanje novih kolona vezanih za user konverzacije u g1,g2 i g3 tabele

ALTER TABLE netflow.user_mapping_conversation_g1 ADD COLUMN is_source_initiator boolean DEFAULT true;
ALTER TABLE netflow.user_mapping_conversation_g2 ADD COLUMN is_source_initiator boolean DEFAULT true;
ALTER TABLE netflow.user_mapping_conversation_g3 ADD COLUMN is_source_initiator boolean DEFAULT true;


-- izmena procedura za agregaciju konverzacija exportera

DROP FUNCTION netflow.bulk_agg_exporter_device_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone);

CREATE OR REPLACE FUNCTION netflow.bulk_agg_exporter_device_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone)
  RETURNS void
STRICT
LANGUAGE plpgsql
AS $$
DECLARE
  srctable TEXT;
  dsttable TEXT;
BEGIN
  srctable := 'netflow.exporter_device_conversation_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.exporter_device_conversation_' || dstgrain || '_' || dstsuffix;
  EXECUTE 'INSERT INTO ' || dsttable::regclass || ' (time, exporter, source, destination, service, byte_src, byte_dst, pack_src, pack_dst, flow_src, flow_dst, protocol,is_source_initiator)
	SELECT $2, exporter, source, destination, service, SUM(byte_src) AS byte_src, SUM(byte_dst) AS byte_dst, SUM(pack_src) AS pack_src, SUM(pack_dst) as pack_dst, SUM(flow_src) AS flow_src,
    SUM(flow_dst) as flow_dst, protocol,  bool_and(is_source_initiator) as is_source_initiator FROM ' || srctable::regclass || '
	WHERE "time" > $1 AND "time" <= $2
	GROUP BY exporter, source, destination, service, protocol' USING t1, t2;
END;
$$;


DROP FUNCTION netflow.upsert_exporter_device_conversation(g text, s text, b bigint, p bigint, f bigint, ip inet, ip_src inet, ip_dst inet, srv integer, t timestamp without time zone, prot integer);

CREATE OR REPLACE FUNCTION netflow.upsert_exporter_device_conversation(g text, s text, b_src bigint, b_dst bigint, p_src bigint, p_dst bigint, f_src bigint, f_dst bigint, ip inet, ip_src inet, ip_dst inet, srv integer, t timestamp without time zone, prot integer, is_src_ini boolean)
  RETURNS void
STRICT
LANGUAGE plpgsql
AS $$
DECLARE
  row RECORD;
  tablename text;
BEGIN
  tablename := 'netflow.exporter_device_conversation_' || g || '_' || s;
  EXECUTE 'SELECT byte_src, byte_dst, pack_src, pack_dst,flow_src, flow_dst, is_source_initiator FROM ' || tablename::regclass || ' WHERE time = $1 AND exporter = $2 AND source = $3 AND destination = $4 AND service = $5  AND protocol = $6' INTO row USING t, ip, ip_src, ip_dst, srv, prot;
  IF row IS NOT NULL THEN
    EXECUTE 'UPDATE ' || tablename::regclass || ' SET byte_src = $1, byte_dst = $2, pack_src = $3, pack_dst = $4 flow_src = $5, flow_dst = $6, is_source_initiator=$7 WHERE time = $8 AND exporter = $9 AND source = $10 AND destination = $11 AND service = $12 AND protocol = $13'
	USING row.byte_src+b_src, row.byte_dst+b_dst, row.pack_src+p_src, row.pack_dst+p_dst, row.flow_src+f_src, row.flow_dst+f_dst, (row.is_source_initiator AND is_src_ini), t, ip, ip_src, ip_dst, srv, prot;
  ELSE
    EXECUTE 'INSERT INTO ' || tablename::regclass || '(time, exporter, source, destination, service, byte_src, byte_dst, pack_src, pack_dst, flow_src, flow_dst, protocol, is_source_initiator) VALUES($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13)' USING t, ip, ip_src, ip_dst, srv, b_src, b_dst, p_src, p_dst, f_src, f_dst, prot, is_src_ini;
  END IF;
END;
$$;

DROP FUNCTION netflow.aggregate_exporter_device_conversation(s1 text, s2 text, s3 text, t1 timestamp without time zone, t2 timestamp without time zone, t3 timestamp without time zone);

CREATE OR REPLACE FUNCTION netflow.aggregate_exporter_device_conversation(s1 text, s2 text, s3 text, t1 timestamp without time zone, t2 timestamp without time zone, t3 timestamp without time zone)
  RETURNS void
  STRICT
LANGUAGE plpgsql
AS $$
DECLARE
  g1table TEXT;
  g1data RECORD;
BEGIN
  g1table := 'netflow.exporter_device_conversation_g1_' || s1;
  FOR g1data IN EXECUTE 'SELECT * FROM ' || g1table::regclass || ' WHERE time = $1' USING t1 LOOP
    PERFORM netflow.upsert_exporter_device_conversation('g2',s2,g1data.byte_src,g1data.byte_dst,g1data.pack_src,g1data.pack_dst,g1data.flow_src,g1data.flow_dst,g1data.exporter,g1data.source,g1data.destination,g1data.service,t2, g1data.protocol, g1data.is_source_initiator);
    PERFORM netflow.upsert_exporter_device_conversation('g3',s3,g1data.byte_src,g1data.byte_dst,g1data.pack_src,g1data.pack_dst,g1data.flow_src,g1data.flow_dst,g1data.exporter,g1data.source,g1data.destination,g1data.service,t3, g1data.protocol, g1data.is_source_initiator);
  END LOOP;
END;
$$;


DROP FUNCTION netflow.agg_exporter_device_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone);
CREATE OR REPLACE FUNCTION netflow.agg_exporter_device_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone)
  RETURNS void
STRICT
LANGUAGE plpgsql
AS $$
DECLARE
  srctable TEXT;
  dsttable TEXT;
  srcdata RECORD;
BEGIN
  srctable := 'netflow.exporter_device_conversation_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.exporter_device_conversation_' || dstgrain || '_' || dstsuffix;
  FOR srcdata IN EXECUTE 'SELECT exporter, source, destination, service, SUM(byte_src) AS byte_src, SUM(byte_dst) as byte_dst, SUM(pack_src) AS pack_src, SUM(pack_dst) as pack_dst, SUM(flow_src) AS flow_src, SUM(flow_dst) as flow_dst, protocol, bool_and(is_source_initiator) as is_src_ini FROM ' || srctable::regclass || ' WHERE "time" > $1 AND "time" <= $2 GROUP BY exporter, source, destination, service, protocol' USING t1, t2 LOOP
    EXECUTE 'INSERT INTO ' || dsttable::regclass || ' (time, exporter, source, destination, service, byte_src, byte_dst, pack_src, pack_dst, flow_src, flow_dst, protocol, is_source_initiator) VALUES($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13)' USING t2, srcdata.exporter, srcdata.source, srcdata.destination, srcdata.service, srcdata.byte_src, srcdata.byte_dst, srcdata.pack_src, srcdata.pack_dst, srcdata.flow_src, srcdata.flow_dst, srcdata.protocol, srcdata.is_src_ini;
  END LOOP;
END;
$$;

--izmena procedure za agregaciju konverzacija interfejsa

DROP FUNCTION netflow.bulk_agg_exporter_interface_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone);
CREATE OR REPLACE FUNCTION netflow.bulk_agg_exporter_interface_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone)
  RETURNS void
STRICT
LANGUAGE plpgsql
AS $$
DECLARE
  srctable TEXT;
  dsttable TEXT;
BEGIN
  srctable := 'netflow.exporter_interface_conversation_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.exporter_interface_conversation_' || dstgrain || '_' || dstsuffix;
  EXECUTE 'INSERT INTO ' || dsttable::regclass || ' (time, exporter, interface, source, destination, service, byte_src_in, byte_src_out, byte_dst_in, byte_dst_out,
  pack_src_in, pack_src_out, pack_dst_in, pack_dst_out, flow_src_in, flow_src_out, flow_dst_in, flow_dst_out, protocol, is_source_initiator)
  SELECT $2, exporter, interface, source, destination, service, SUM(byte_src_in) AS byte_src_in, SUM(byte_src_out) as byte_src_out, SUM(byte_dst_in) as byte_dst_in, SUM(byte_dst_out) as byte_dst_out,
  SUM(pack_src_in) AS pack_src_in, SUM(pack_src_out) as pack_src_out, SUM(pack_dst_in) as pack_dst_in, SUM(pack_dst_out) AS pack_dst_out, SUM(flow_src_in) AS flow_src_in, SUM(flow_src_out) as flow_src_out,
  SUM(flow_dst_in) as flow_dst_in, SUM(flow_dst_out) AS flow_dst_out, protocol,  bool_and(is_source_initiator) as is_source_initiator
  FROM ' || srctable::regclass || '
  WHERE "time" > $1 AND "time" <= $2
  GROUP BY exporter, interface, source, destination, service, protocol' USING t1, t2;
END;
$$;

DROP FUNCTION netflow.agg_exporter_interface_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone);
CREATE OR REPLACE FUNCTION netflow.agg_exporter_interface_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone)
  RETURNS void
STRICT
LANGUAGE plpgsql
AS $$
DECLARE
  srctable TEXT;
  dsttable TEXT;
  srcdata RECORD;
BEGIN
  srctable := 'netflow.exporter_interface_conversation_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.exporter_interface_conversation_' || dstgrain || '_' || dstsuffix;
  FOR srcdata IN EXECUTE 'SELECT exporter, interface, source, destination, service, SUM(byte_src_in) AS byte_src_in, SUM(byte_src_out) AS byte_src_out, SUM(byte_dst_in) as byte_dst_in, SUM(byte_dst_out) AS byte_dst_out,
  SUM(pack_src_in) AS pack_src_in, SUM(pack_src_out) AS pack_src_out, SUM(pack_dst_in) AS pack_dst_in, SUM(pack_dst_out) AS pack_dst_out,
  SUM(flow_src_in) AS flow_src_in, SUM(flow_src_out) AS flow_src_out, SUM(flow_dst_in) AS flow_dst_in, SUM(flow_dst_out) AS flow_dst_out,
  protocol, AND(is_source_initiator) as is_source_initiator FROM ' || srctable::regclass || ' WHERE "time" > $1 AND "time" <= $2 GROUP BY exporter, interface, source, destination, service, protocol' USING t1, t2 LOOP
    EXECUTE 'INSERT INTO ' || dsttable::regclass || ' (time, exporter, interface, source, destination, service,
	byte_src_in, byte_src_out, byte_dst_in, byte_dst_out,
	pack_src_in, pack_src_out, pack_dst_in, pack_dst_out,
	flow_src_in, flow_src_out flow_dst_in, flow_dst_out,
	protocol, is_source_initiator) VALUES($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19, $20)' USING t2, srcdata.exporter, srcdata.interface, srcdata.source, srcdata.destination, srcdata.service,
	srcdata.byte_src_in, srcdata.byte_src_out, srcdata.byte_dst_in, srcdata.byte_dst_out,
	srcdata.pack_src_in, srcdata.pack_src_out, srcdata.pack_dst_in, srcdata.pack_dst_out,
	srcdata.flow_src_in, srcdata.flow_src_out, srcdata.flow_dst_in, srcdata.flow_dst_out,
	srcdata.protocol, srcdata.is_source_initiator;
  END LOOP;
END;
$$;

DROP FUNCTION netflow.upsert_exporter_interface_conversation(g text, s text, b_in bigint, b_out bigint, p_in bigint, p_out bigint, f_in bigint, f_out bigint, ip inet, ifc integer, ip_src inet, ip_dst inet, srv integer, t timestamp without time zone, prot integer);
CREATE OR REPLACE FUNCTION netflow.upsert_exporter_interface_conversation(g text, s text, b_src_in bigint, b_src_out bigint, b_dst_in bigint, b_dst_out bigint, p_src_in bigint, p_src_out bigint, p_dst_in bigint, p_dst_out bigint, f_src_in bigint, f_src_out bigint, f_dst_in bigint, f_dst_out bigint, ip inet, ifc integer, ip_src inet, ip_dst inet, srv integer, t timestamp without time zone, prot integer, is_src_ini boolean)
  RETURNS void
STRICT
LANGUAGE plpgsql
AS $$
DECLARE
  row RECORD;
  tablename text;
BEGIN
  tablename := 'netflow.exporter_interface_conversation_' || g || '_' || s;
  EXECUTE 'SELECT byte_src_in, byte_src_out, byte_dst_in, byte_dst_out, pack_src_in, pack_src_out, pack_dst_in, pack_dst_out, flow_src_in,flow_src_out, flow_dst_in, flow_dst_out, is_source_initiator FROM ' || tablename::regclass || ' WHERE time = $1 AND exporter = $2 AND interface = $3 AND source = $4 AND destination = $5 AND service = $6 AND protocol = $7' INTO row USING t, ip, ifc, ip_src, ip_dst, srv, prot;
  IF row IS NOT NULL THEN
    EXECUTE 'UPDATE ' || tablename::regclass || ' SET byte_src_in = $1, byte_src_out = $2, byte_dst_in = $3, byte_dst_out = $4,
	pack_src_in = $5, pack_src_out = $6, pack_dst_in = $7, pack_dst_out = $8,
	flow_src_in = $9, flow_src_out = $10, flow_dst_in= $11, flow_dst_out = $12, is_source_initiator = $13
	WHERE time = $14 AND exporter = $15 AND interface = $16 AND source = $17 AND destination = $18 AND service = $19 AND protocol = $20'
	USING
	row.byte_src_in+b_src_in, row.byte_src_out+b_src_out, row.byte_dst_in+b_dst_in, row.byte_dst_out+b_dst_out,
	row.pack_src_in+p_src_in, row.pack_src_out+p_src_out, row.pack_dst_in+p_dst_in, row.pack_dst_out+p_dst_out,
  row.flow_src_in+f_src_in, row.flow_src_out+f_src_out, row.flow_dst_in+f_dst_in, row.flow_dst_out+f_dst_out, bool_and(row.is_source_initiator,is_src_ini),
   t, ip, ifc, ip_src, ip_dst, srv, prot;
  ELSE
    EXECUTE 'INSERT INTO ' || tablename::regclass || '(time, exporter, interface, source, destination, service, byte_src_in, byte_src_out, byte_dst_in, byte_dst_out, pack_src_in, pack_src_out, pack_dst_in, pack_dst_out,
       flow_src_in, flow_src_out, flow_dst_in, flow_dst_out, protocol, is_source_initiator) VALUES($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19, $20)' USING t, ip, ifc, ip_src, ip_dst, srv, b_src_in, b_src_out, b_dst_in, b_dst_out, p_src_in, p_src_out, p_dst_in, p_dst_out, f_src_in, f_src_out, f_dst_in, f_dst_out, prot, is_src_ini;
  END IF;
END;
$$;

DROP FUNCTION netflow.aggregate_exporter_interface_conversation(s1 text, s2 text, s3 text, t1 timestamp without time zone, t2 timestamp without time zone, t3 timestamp without time zone);
CREATE OR REPLACE FUNCTION netflow.aggregate_exporter_interface_conversation(s1 text, s2 text, s3 text, t1 timestamp without time zone, t2 timestamp without time zone, t3 timestamp without time zone)
  RETURNS void
LANGUAGE plpgsql
AS $$
DECLARE
  g1table TEXT;
  g1data RECORD;
BEGIN
  g1table := 'netflow.exporter_interface_conversation_g1_' || s1;
  FOR g1data IN EXECUTE 'SELECT * FROM ' || g1table::regclass || ' WHERE time = $1' USING t1 LOOP
    PERFORM netflow.upsert_exporter_interface_conversation('g2',s2,g1data.byte_src_in,g1data.byte_src_out,g1data.byte_dst_in,g1data.byte_dst_out,g1data.pack_src_in,g1data.pack_src_out,g1data.pack_dst_in,g1data.pack_dst_out,g1data.flow_src_in,g1data.flow_src_out,g1data.flow_dst_in,g1data.flow_dst_out,g1data.exporter,g1data.interface,g1data.source,g1data.destination,g1data.service,t2, g1data.protocol, g1data.is_source_initiator);
    PERFORM netflow.upsert_exporter_interface_conversation('g3',s3,g1data.byte_src_in,g1data.byte_src_out,g1data.byte_dst_in,g1data.byte_dst_out,g1data.pack_src_in,g1data.pack_src_out,g1data.pack_dst_in,g1data.pack_dst_out,g1data.flow_src_in,g1data.flow_src_out,g1data.flow_dst_in,g1data.flow_dst_out,g1data.exporter,g1data.interface,g1data.source,g1data.destination,g1data.service,t3, g1data.protocol, g1data.is_source_initiator);
  END LOOP;
END;
$$;



--izmena procedure za agregaciju konverzacija subneta

DROP FUNCTION netflow.bulk_agg_pattern_subnet_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone);
CREATE OR REPLACE FUNCTION netflow.bulk_agg_pattern_subnet_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone)
  RETURNS void
STRICT
LANGUAGE plpgsql
AS $$
DECLARE
  srctable TEXT;
  dsttable TEXT;
BEGIN
  srctable := 'netflow.pattern_subnet_conversation_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.pattern_subnet_conversation_' || dstgrain || '_' || dstsuffix;
  EXECUTE 'INSERT INTO ' || dsttable::regclass || ' (time, pattern, subnet, set, source, destination, service, byte_src_in, byte_src_out, byte_dst_in, byte_dst_out,
  pack_src_in, pack_src_out, pack_dst_in, pack_dst_out, flow_src_in, flow_src_out, flow_dst_in, flow_dst_out, protocol, is_source_initiator)
  SELECT $2, pattern, subnet, set, source, destination, service, SUM(byte_src_in) AS byte_src_in, SUM(byte_src_out) as byte_src_out, SUM(byte_dst_in) as byte_dst_in, SUM(byte_dst_out) as byte_dst_out,
  SUM(pack_src_in) AS pack_src_in, SUM(pack_src_out) as pack_src_out, SUM(pack_dst_in) as pack_dst_in, SUM(pack_dst_out) AS pack_dst_out, SUM(flow_src_in) AS flow_src_in, SUM(flow_src_out) as flow_src_out,
  SUM(flow_dst_in) as flow_dst_in, SUM(flow_dst_out) AS flow_dst_out, protocol,  bool_and(is_source_initiator) as is_source_initiator
  FROM ' || srctable::regclass || '
  WHERE "time" > $1 AND "time" <= $2
  GROUP BY pattern, subnet, set, source, destination, service, protocol' USING t1, t2;
END;
$$;

DROP FUNCTION netflow.aggregate_pattern_subnet_conversation(s1 text, s2 text, s3 text, t1 timestamp without time zone, t2 timestamp without time zone, t3 timestamp without time zone);
CREATE FUNCTION netflow.aggregate_pattern_subnet_conversation(s1 text, s2 text, s3 text, t1 timestamp without time zone, t2 timestamp without time zone, t3 timestamp without time zone)
  RETURNS void
LANGUAGE plpgsql
AS $$
DECLARE
  g1table TEXT;
  g1data RECORD;
BEGIN
  g1table := 'netflow.pattern_subnet_conversation_g1_' || s1;
  FOR g1data IN EXECUTE 'SELECT * FROM ' || g1table::regclass || ' WHERE time = $1' USING t1 LOOP
    PERFORM netflow.upsert_pattern_subnet_conversation('g2',s2,g1data.byte_src_in,g1data.byte_src_out,g1data.byte_dst_in, g1data.byte_dst_out,g1data.pack_src_in,g1data.pack_src_out,g1data.pack_dst_in, g1data.pack_dst_out,g1data.flow_src_in,g1data.flow_src_out,g1data.flow_dst_in, g1data.flow_dst_out,g1data.pattern,g1data.subnet,g1data.set,g1data.source,g1data.destination,g1data.service,t2, g1data.protocol, g1data.is_source_initiator);
    PERFORM netflow.upsert_pattern_subnet_conversation('g3',s3,g1data.byte_src_in,g1data.byte_src_out,g1data.byte_dst_in, g1data.byte_dst_out,g1data.pack_src_in,g1data.pack_src_out,g1data.pack_dst_in, g1data.pack_dst_out,g1data.flow_src_in,g1data.flow_src_out,g1data.flow_dst_in, g1data.flow_dst_out,g1data.pattern,g1data.subnet,g1data.set,g1data.source,g1data.destination,g1data.service,t3, g1data.protocol, g1data.is_source_initiator);
  END LOOP;
END;
$$;

DROP FUNCTION netflow.upsert_pattern_subnet_conversation(g text, s text, b_in bigint, b_out bigint, p_in bigint, p_out bigint, f_in bigint, f_out bigint, pattern integer, subnet integer, subnetset integer, ip_src inet, ip_dst inet, srv integer, t timestamp without time zone, prot integer);
CREATE OR REPLACE FUNCTION netflow.upsert_pattern_subnet_conversation(g text, s text, b_src_in bigint, b_src_out bigint, b_dst_in bigint, b_dst_out bigint, p_src_in bigint, p_src_out bigint, p_dst_in bigint, p_dst_out bigint, f_src_in bigint, f_src_out bigint, f_dst_in bigint, f_dst_out bigint, pattern integer, subnet integer, subnetset integer, ip_src inet, ip_dst inet, srv integer, t timestamp without time zone, prot integer, is_src_ini boolean)

  RETURNS void
LANGUAGE plpgsql
AS $$
DECLARE
  row RECORD;
  tablename text;
  sel text;
  upd text;
BEGIN
  tablename := 'netflow.pattern_subnet_conversation_' || g || '_' || s;
  sel := 'SELECT byte_src_in,byte_src_out, byte_dst_in, byte_dst_out, pack_src_in,pack_src_out, pack_dst_in, pack_dst_out, flow_src_in,flow_src_out,flow_dst_in, flow_dst_out, is_source_initiator FROM ' || tablename::regclass || ' WHERE time = $1 AND source = $2 AND destination = $3 AND service = $4 AND pattern = $5 ';
  IF subnet IS NULL AND subnetset IS NULL THEN
   sel := sel || 'AND protocol = $6 AND subnet IS NULL AND set IS NULL';
   EXECUTE sel INTO row USING t, ip_src, ip_dst, srv, pattern, prot;
  ELSIF subnetset IS NULL THEN
   sel := sel || 'AND subnet = $6 AND protocol = $7 AND set IS NULL';
   EXECUTE sel INTO row USING t, ip_src, ip_dst, srv, pattern, subnet, prot;
  ELSIF subnet IS NULL THEN
   sel := sel || 'AND set = $6 AND protocol = $7 AND subnet IS NULL';
   EXECUTE sel INTO row USING t, ip_src, ip_dst, srv, pattern, subnetset, prot;
  END IF;

  IF row IS NOT NULL THEN
    upd := 'UPDATE ' || tablename::regclass || ' SET byte_src_in = $1, byte_src_out = $2, byte_dst_in = $3, byte_dst_out = $4, pack_src_in = $5, pack_src_out = $6, pack_dst_in = $7, pack_dst_out = $8, flow_src_in = $9, flow_src_out = $10, flow_dst_in = $11, flow_dst_out = $12, is_source_initiator= $13  WHERE time = $14 AND source = $15 AND destination = $16 AND service = $17 AND pattern = $18 ';
    IF subnet IS NULL AND subnetset IS NULL THEN
	  upd := upd || 'AND protocol = $19 AND subnet IS NULL AND set IS NULL';
      EXECUTE upd USING row.byte_src_in+b_src_in, row.byte_src_out+b_src_out, row.byte_dst_in+b_dst_in, row.byte_dst_out+b_dst_out, row.pack_src_in+p_src_in, row.pack_src_out+p_src_out, row.pack_dst_in+ p_dst_in, row.pack_dst_out + p_dst_out, row.flow_src_in+f_src_in, row.flow_src_out+f_src_out, row.flow_dst_in+ f_dst_in, row.flow_dst_out + f_dst_out, is_src_ini and row.is_source_initiator, t, ip_src, ip_dst, srv, pattern, prot;
	ELSIF subnetset IS NULL THEN
      upd := upd || 'AND subnet = $19 AND protocol = $20 AND set IS NULL';
      EXECUTE upd USING row.byte_src_in+b_src_in, row.byte_src_out+b_src_out, row.byte_dst_in+b_dst_in, row.byte_dst_out+b_dst_out, row.pack_src_in+p_src_in, row.pack_src_out+p_src_out, row.pack_dst_in+ p_dst_in, row.pack_dst_out + p_dst_out, row.flow_src_in+f_src_in, row.flow_src_out+f_src_out, row.flow_dst_in+ f_dst_in, row.flow_dst_out + f_dst_out, is_src_ini and row.is_source_initiator, t, ip_src, ip_dst, srv, pattern, subnet, prot;
    ELSIF subnet IS NULL THEN
      upd := upd || 'AND set = $19 AND protocol = $20 AND subnet IS NULL';
      EXECUTE upd USING row.byte_src_in+b_src_in, row.byte_src_out+b_src_out, row.byte_dst_in+b_dst_in, row.byte_dst_out+b_dst_out, row.pack_src_in+p_src_in, row.pack_src_out+p_src_out, row.pack_dst_in+ p_dst_in, row.pack_dst_out + p_dst_out, row.flow_src_in+f_src_in, row.flow_src_out+f_src_out, row.flow_dst_in+ f_dst_in, row.flow_dst_out + f_dst_out, is_src_ini and row.is_source_initiator, t, ip_src, ip_dst, srv, pattern, subnetset, prot;
    END IF;
  ELSE
    EXECUTE 'INSERT INTO ' || tablename::regclass || '(time, pattern, subnet, set, source, destination, service, byte_src_in, byte_src_out, byte_dst_in, byte_dst_out, pack_src_in, pack_src_out, pack_dst_in, pack_dst_out, flow_src_in, flow_src_out, flow_dst_in, flow_dst_out, is_source_initiator, protocol) VALUES($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19, $20, $21)' USING t, pattern, subnet, subnetset, ip_src, ip_dst, srv, b_src_in, b_src_out, b_dst_in, b_dst_out, p_src_in, p_src_out, p_dst_in, p_dst_out, f_src_in, f_src_out, f_dst_in, f_dst_out, is_src_ini, prot;
  END IF;
END;
$$;

DROP FUNCTION netflow.agg_pattern_subnet_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone);
CREATE OR REPLACE FUNCTION netflow.agg_pattern_subnet_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone)
  RETURNS void
STRICT
LANGUAGE plpgsql
AS $$
DECLARE
  srctable TEXT;
  dsttable TEXT;
  srcdata RECORD;
BEGIN
  srctable := 'netflow.pattern_subnet_conversation_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.pattern_subnet_conversation_' || dstgrain || '_' || dstsuffix;
  FOR srcdata IN EXECUTE 'SELECT pattern, subnet, set, source, destination, service, SUM(byte_src_in) AS byte_src_in, SUM(byte_src_out) AS byte_src_out, SUM(byte_dst_in) AS byte_dst_in, SUM(byte_dst_out) AS byte_dst_out, SUM(pack_src_in) AS pack_src_in, SUM(pack_src_out) AS pack_src_out, SUM(pack_dst_in) AS pack_dst_in, SUM(pack_dst_out) AS pack_dst_out, SUM(flow_src_in) AS flow_src_in, SUM(flow_src_out) AS flow_src_out, SUM(flow_dst_in) AS flow_dst_in, SUM(flow_dst_out) AS flow_dst_out, bool_and(is_source_initiator) as is_source_initiator, protocol FROM ' || srctable::regclass || ' WHERE "time" > $1 AND "time" <= $2 GROUP BY pattern, subnet, set, source, destination, service, protocol' USING t1, t2 LOOP
    EXECUTE 'INSERT INTO ' || dsttable::regclass || ' (time, pattern, subnet, set, source, destination, service,  byte_src_in, byte_src_out, byte_dst_in, byte_dst_out,
  pack_src_in, pack_src_out, pack_dst_in, pack_dst_out, flow_src_in, flow_src_out, flow_dst_in, flow_dst_out, is_source_initiator,  protocol) VALUES($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19, $20, $21)' USING t2, srcdata.pattern, srcdata.subnet, srcdata.set, srcdata.source, srcdata.destination, srcdata.service, srcdata.byte_src_in, srcdata.byte_src_out, srcdata.byte_dst_in, srcdata.byte_dst_out, srcdata.pack_src_in, srcdata.pack_src_out, srcdata.pack_dst_in, srcdata.pack_dst_out, srcdata.flow_src_in, srcdata.flow_src_out, srcdata.flow_dst_in, srcdata.flow_dst_out, srcdata.is_source_initiator, srcdata.protocol;
  END LOOP;
END;
$$;

--izmena procedure za agregaciju konverzacija user-a
DROP FUNCTION netflow.bulk_agg_user_mapping_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone);
CREATE OR REPLACE FUNCTION netflow.bulk_agg_user_mapping_conversation(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone)
  RETURNS void
STRICT
LANGUAGE plpgsql
AS $$
DECLARE
  srctable TEXT;
  dsttable TEXT;
BEGIN
  srctable := 'netflow.user_mapping_conversation_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.user_mapping_conversation_' || dstgrain || '_' || dstsuffix;
  EXECUTE 'INSERT INTO ' || dsttable::regclass || ' (time, user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator)
  SELECT $2, user_id, source, destination, service, protocol, SUM(byte_download) AS byte_download, SUM(byte_upload) AS byte_upload, SUM(pack_download) AS pack_download, SUM(pack_upload) AS pack_upload, SUM(flow_download) AS flow_download, SUM(flow_upload) AS flow_upload,
  bool_and(is_source_initiator) as is_source_initiator
  FROM ' || srctable::regclass || '
  WHERE "time" > $1 AND "time" <= $2
  GROUP BY user_id, source, destination, service, protocol' USING t1, t2;
END;
$$;

--izmena procedure za agregaciju top n konverzacija

DROP FUNCTION netflow.bulk_agg_user_mapping_conversation_top_n(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone, topn integer);
CREATE OR REPLACE FUNCTION netflow.bulk_agg_user_mapping_conversation_top_n(srcsuffix text, srcgrain text, dstsuffix text, dstgrain text, t1 timestamp without time zone, t2 timestamp without time zone, topn integer)
  RETURNS void
STRICT
LANGUAGE plpgsql
AS $$
DECLARE
  srctable TEXT;
  dsttable TEXT;
BEGIN
  srctable := 'netflow.user_mapping_conversation_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.user_mapping_conversation_' || dstgrain || '_' || dstsuffix;
  EXECUTE 'CREATE TEMP TABLE conv_kes
	ON COMMIT DROP
	AS
	SELECT $1, user_id, source, destination, service, protocol, SUM(byte_download) AS byte_download, SUM(byte_upload) AS byte_upload, SUM(pack_download) AS pack_download, SUM(pack_upload) AS pack_upload, SUM(flow_download) AS flow_download, SUM(flow_upload) AS flow_upload, bool_and(is_source_initiator) AS is_source_initiator
	FROM ' || srctable::regclass || '
	WHERE "time" > $1 AND "time" <= $2
	GROUP BY user_id, source, destination, service, protocol
	ORDER BY user_id;
	'
USING t1, t2;

CREATE INDEX conv_kes_index_on_user_id ON conv_kes USING hash (user_id);

EXECUTE 'INSERT INTO ' || dsttable::regclass || '
	(time, user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator)
	(
		SELECT
			$2, user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator
		FROM (
			select
				user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator,
				row_number() OVER(PARTITION BY user_id ORDER BY byte_upload DESC) <= $1 as rnk
			from conv_kes
			order by rnk
		) sub
		where rnk = true
	) UNION
	(
		SELECT
			$2, user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator
		FROM (
			select
				user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator,
				row_number() OVER(PARTITION BY user_id ORDER BY byte_download DESC) <= $1 as rnk
			from conv_kes
			order by rnk
		) sub
		where rnk = true
	) UNION
	(
		SELECT
			$2, user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator
		FROM (
			select
				user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator,
				row_number() OVER(PARTITION BY user_id ORDER BY pack_upload DESC) <= $1 as rnk
			from conv_kes
			order by rnk
		) sub
		where rnk = true
	) UNION
	(
		SELECT
			$2, user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator
		FROM (
			select
				user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator,
				row_number() OVER(PARTITION BY user_id ORDER BY pack_download DESC) <= $1 as rnk
			from conv_kes
			order by rnk
		) sub
		where rnk = true
	) UNION
	(
		SELECT
			$2, user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator
		FROM (
			select
				user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator,
				row_number() OVER(PARTITION BY user_id ORDER BY flow_upload DESC) <= $1 as rnk
			from conv_kes
			order by rnk
		) sub
		where rnk = true
	) UNION
	(
		SELECT
			$2, user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator
		FROM (
			select
				$2, user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload, is_source_initiator,
				row_number() OVER(PARTITION BY user_id ORDER BY flow_download DESC) <= $1 as rnk
			from conv_kes
			order by rnk
		) sub
		where rnk = true
	)'
USING topn, t2;

END;
$$;

--NVDEV-885 Preimenovanje Discard interfejsa u Null

UPDATE device.subdevice SET name='Null'
WHERE name='Discard' AND index = '0';

--NVDEV-885 Izmena opisa interfejsa iz 'Network discarded packets' u 'Traffic dropped'
UPDATE device.subdevice SET description='Traffic dropped'
WHERE description='Netflow discarded packets' AND index='0';


--NVDEV-879 Update ASN-ova
ALTER TABLE mapping.asinfo
ADD edited boolean DEFAULT false;

-- dodavanje tabela radi razvrstavanja inicijatora i respondera na konverzacijama

ALTER TABLE netflow.exporter_device_total_g1 ADD COLUMN byte_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g1 ADD COLUMN pack_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g1 ADD COLUMN flow_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g1 ADD COLUMN byte_resp bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g1 ADD COLUMN pack_resp bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g1 ADD COLUMN flow_resp bigint DEFAULT 0;

ALTER TABLE netflow.exporter_device_total_g2 ADD COLUMN byte_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g2 ADD COLUMN pack_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g2 ADD COLUMN flow_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g2 ADD COLUMN byte_resp bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g2 ADD COLUMN pack_resp bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g2 ADD COLUMN flow_resp bigint DEFAULT 0;

ALTER TABLE netflow.exporter_device_total_g3 ADD COLUMN byte_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g3 ADD COLUMN pack_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g3 ADD COLUMN flow_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g3 ADD COLUMN byte_resp bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g3 ADD COLUMN pack_resp bigint DEFAULT 0;
ALTER TABLE netflow.exporter_device_total_g3 ADD COLUMN flow_resp bigint DEFAULT 0;

-- dodavanje tabela radi razvrstavanja inicijatora i respondera na exporterima

ALTER TABLE netflow.exporter_interface_total_g1 ADD COLUMN byte_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g1 ADD COLUMN pack_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g1 ADD COLUMN flow_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g1 ADD COLUMN byte_resp bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g1 ADD COLUMN pack_resp bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g1 ADD COLUMN flow_resp bigint DEFAULT 0;

ALTER TABLE netflow.exporter_interface_total_g2 ADD COLUMN byte_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g2 ADD COLUMN pack_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g2 ADD COLUMN flow_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g2 ADD COLUMN byte_resp bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g2 ADD COLUMN pack_resp bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g2 ADD COLUMN flow_resp bigint DEFAULT 0;

ALTER TABLE netflow.exporter_interface_total_g3 ADD COLUMN byte_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g3 ADD COLUMN pack_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g3 ADD COLUMN flow_init bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g3 ADD COLUMN byte_resp bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g3 ADD COLUMN pack_resp bigint DEFAULT 0;
ALTER TABLE netflow.exporter_interface_total_g3 ADD COLUMN flow_resp bigint DEFAULT 0;

INSERT INTO framework.db_version(patch_number, patch_date) VALUES (71, current_timestamp);
