-- Fix: constraint za brisanje resursa prilikom brisanja resource type-a

ALTER TABLE device.resource DROP CONSTRAINT fk_resource_resource_type;

ALTER TABLE device.resource
  ADD CONSTRAINT fk_resource_resource_type FOREIGN KEY (id_resource_type)
      REFERENCES typology.resource_type (id_resource_type) MATCH FULL
      ON UPDATE CASCADE ON DELETE CASCADE;
      
      -- Fix: constraint za brisanje kompozitnih resursa prilikom brisanja kompozitnog resource type-a


ALTER TABLE device.resource_composite DROP CONSTRAINT fk_resource_composite_resource_composite_type;

ALTER TABLE device.resource_composite
  ADD CONSTRAINT fk_resource_composite_resource_composite_type FOREIGN KEY (id_resource_composite_type)
      REFERENCES typology.resource_composite_type (id_resource_composite_type) MATCH FULL
      ON UPDATE CASCADE ON DELETE CASCADE;
      

INSERT INTO framework.db_version(patch_number, patch_date) VALUES (74, current_timestamp);