-- UPDATE 09.08.2017.

-- NVDEV-770

-- promena imena alarma
DO $$
BEGIN
	LOOP 	
		UPDATE netflow_conf.alarm
		SET name = alarm_subquery.dup_name || '_' || alarm_subquery.rank
		FROM
		(SELECT * FROM (SELECT 
		           id, 
		           name AS dup_name, 
		           rank() OVER (
		             PARTITION BY name 
		             ORDER BY id  
		            ) 
		    	FROM netflow_conf.alarm ) sub WHERE sub.rank > 1 ) AS alarm_subquery
		WHERE netflow_conf.alarm.id = alarm_subquery.id;
			
		IF NOT FOUND THEN 
			EXIT;
		END IF;
	
	END LOOP;
END $$; 

--dodaje constraint na ime
ALTER TABLE netflow_conf.alarm ADD CONSTRAINT unique_alarm_name UNIQUE (name);

-- UPDATE 23.08.2017.

-- NVDEV-776 za schedule report-a za exporter tagove 

ALTER TABLE netflow_conf.report ADD COLUMN exporter_tag_id bigint;
ALTER TABLE netflow_conf.report ADD COLUMN exporter_untagged boolean;
ALTER TABLE netflow_conf.report ADD COLUMN "tag_name" character varying(40);

INSERT INTO framework.db_version(patch_number, patch_date) VALUES (66, current_timestamp);