-- UPDATE 22.11.2017.

-- NVDEV-739

-- kreiranje grupa monitora

-- izmena naziva NMS modula

UPDATE framework.module set name = 'Network', settings_item = 'Network settings', description = 'Network Monitor' where tag = 'nms';
UPDATE framework.module set  description = 'Alarms' where tag = 'alarm';
UPDATE framework.module set  description = 'MIB Browser' where tag = 'mib';
UPDATE framework.module set  description = 'EventLog Analyzer' where tag = 'eventlog';
UPDATE framework.module set  description = 'NetFlow Analyzer' where tag = 'netflow';



--dodavanje unique constraint-a za id_monitor

ALTER TABLE device.monitor add CONSTRAINT pq_id_monitor PRIMARY KEY (id_monitor);

--kreiranje nove tabele za grupe monitora

CREATE TABLE device.monitor_group
(
   id_monitor_group bigserial NOT NULL, 
   name character varying(256), 
   
   CONSTRAINT pk_monitor_group PRIMARY KEY (id_monitor_group), 
   CONSTRAINT uq_group_name UNIQUE (name)
) 
WITH (
  OIDS = FALSE
);

--kreiranje nove vezne tabele za grupe monitora
CREATE TABLE device.monitor_monitor_group
(
  id_monitor_group bigint NOT NULL,
  id_monitor bigint NOT NULL,
  
  CONSTRAINT pk_monitor_monitor_group PRIMARY KEY (id_monitor, id_monitor_group),
  CONSTRAINT fk_monitor FOREIGN KEY (id_monitor)
      REFERENCES device.monitor (id_monitor) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT fk_monitor_group FOREIGN KEY (id_monitor_group)
      REFERENCES device.monitor_group (id_monitor_group) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE
)
WITH (
  OIDS=FALSE
);


INSERT INTO framework.db_version(patch_number, patch_date) VALUES (69, current_timestamp);